'use strict';

var _require = require('./logger'),
    logger = _require.logger,
    changeLevel = _require.changeLevel;

var _require2 = require('./proxy_server'),
    createProxyServer = _require2.createServer;

var DEFAULT_OPTIONS = {
  host: '127.0.0.1',
  socks: '127.0.0.1:1080',
  proxyListReloadTimeout: 60,
  port: 8080
};

function createServer(opts) {
  var options = Object.assign({}, DEFAULT_OPTIONS, opts);

  if (typeof options.level === 'string') {
    changeLevel(logger, options.level);
  }

  var port = options.port,
      socks = options.socks,
      host = options.host;

  // eslint-disable-next-line

  console.log('SOCKS: ' + socks + '\nhttp-proxy listening: ' + host + ':' + port);

  return createProxyServer(options).listen(port, host);
}

module.exports = {
  createServer: createServer
};